Bug 1009750 - Review Request: python-falcon - High-performance cloud API framework
Review Request: python-falcon - High-performance cloud API framework
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Rex Dieter
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-19 00:11 EDT by Jamie Lennox
Modified: 2015-10-25 21:12 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-03 08:54:44 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rdieter: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jamie Lennox 2013-09-19 00:11:37 EDT
Spec URL: https://dl.dropboxusercontent.com/u/52259114/python-falcon.spec
SRPM URL: https://dl.dropboxusercontent.com/u/52259114/python-falcon-0.1.7-1.fc19.src.rpm
Description: Falcon is a high-performance Python framework for building cloud APIs. It encourages the REST architectural style, and tries to do as little as possible while remaining highly effective. It will be a requirement of the marconi openstack component.
Fedora Account System Username: jamielennox


This is my first package so i am in need of a sponsor.


rawhide: https://koji.fedoraproject.org/koji/taskinfo?taskID=5949439
f19: https://koji.fedoraproject.org/koji/taskinfo?taskID=5949421

rpmbuild]$ rpmlint SRPMS/python-falcon-0.1.7-1.fc19.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
Comment 1 Christopher Meng 2013-09-22 22:35:36 EDT
1. BuildRequires:  python-setuptools-devel

-->

BuildRequires:  python-setuptools

AND

BuildRequires:  python-devel

-->

BuildRequires:  python2-devel


2. rm -rf $RPM_BUILD_ROOT is not needed in modern system.

3. Good to see using %{__python2}, but you forgot it in %install

4. %{python_sitearch} --> %{python2_sitearch}

5. You forgot to use nose or tox to test as RPM %check.

https://github.com/racker/falcon/blob/master/README.md#test

6. No python3 support? Why?

7. You can add features listed on pypi as RPM %description:

Features

- Intuitive routing via URI templates and resource classes
- Easy access to headers and bodies through request and response classes
- Idiomatic HTTP error responses via a handy exception base class
- DRY request processing using global, resource, and method hooks
- Snappy unit testing through WSGI helpers and mocks
- 20% speed boost when Cython is available
- Python 2.6, Python 2.7, PyPy and Python 3.3 support
- Speed, speed, and more speed!
Comment 2 Jamie Lennox 2013-09-23 03:40:05 EDT
Thanks for the review Christopher.

I've updated the SPEC and SRPM. Same location as before. 

$ rpmlint SRPMS/python-falcon-0.1.7-1.fc19.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

f19: http://koji.fedoraproject.org/koji/taskinfo?taskID=5970098
rawhide: http://koji.fedoraproject.org/koji/taskinfo?taskID=5970094
Comment 3 Rex Dieter 2013-10-01 18:09:53 EDT
I can pick up the remainder of the review.
Comment 4 Rex Dieter 2013-10-01 19:10:33 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 33 files have unknown license.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[ ]: Macros in Summary, %description expandable at SRPM build time.
     Note: Macros in: python-falcon (description), python3-falcon
     (description)
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 10 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[ ]: Python eggs must not download any dependencies during the build process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[ ]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-falcon
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-falcon-0.1.7-1.fc20.x86_64.rpm
 
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/response_helpers.so response_helpers.so()(64bit)
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/responders.so responders.so()(64bit)
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/response.so response.so()(64bit)
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/request_helpers.so request_helpers.so()(64bit)
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/request.so request.so()(64bit)
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/http_error.so http_error.so()(64bit)
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/api.so api.so()(64bit)
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/api_helpers.so api_helpers.so()(64bit)
python-falcon.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/falcon/exceptions.so exceptions.so()(64bit)
python-falcon.x86_64: E: non-executable-script /usr/lib64/python2.7/site-packages/falcon/bench/bench.py 0644L /usr/bin/env
python-falcon.x86_64: W: no-manual-page-for-binary falcon-bench
1 packages and 0 specfiles checked; 1 errors, 10 warnings.


Requires
--------
python3-falcon (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython3.3m.so.1.0()(64bit)
    python(abi)
    python3-mimeparse
    python3-six
    rtld(GNU_HASH)

python-falcon (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    python(abi)
    python-mimeparse
    python-six
    rtld(GNU_HASH)



Provides
--------
python3-falcon:
    python3-falcon
    python3-falcon(x86-64)

python-falcon:
    python-falcon
    python-falcon(x86-64)



Unversioned so-files
--------------------
python-falcon: /usr/lib64/python2.7/site-packages/falcon/api.so
python-falcon: /usr/lib64/python2.7/site-packages/falcon/api_helpers.so
python-falcon: /usr/lib64/python2.7/site-packages/falcon/exceptions.so
python-falcon: /usr/lib64/python2.7/site-packages/falcon/http_error.so
python-falcon: /usr/lib64/python2.7/site-packages/falcon/request.so
python-falcon: /usr/lib64/python2.7/site-packages/falcon/request_helpers.so
python-falcon: /usr/lib64/python2.7/site-packages/falcon/responders.so
python-falcon: /usr/lib64/python2.7/site-packages/falcon/response.so
python-falcon: /usr/lib64/python2.7/site-packages/falcon/response_helpers.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/api.cpython-33m.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/api_helpers.cpython-33m.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/exceptions.cpython-33m.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/http_error.cpython-33m.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/request.cpython-33m.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/request_helpers.cpython-33m.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/responders.cpython-33m.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/response.cpython-33m.so
python3-falcon: /usr/lib64/python3.3/site-packages/falcon/response_helpers.cpython-33m.so

Source checksums
----------------
https://pypi.python.org/packages/source/f/falcon/falcon-0.1.7.tar.gz :
  CHECKSUM(SHA256) this package     : cc4f28168ca447be4fd6d8adc458a98ed0a578757d27eb4ebfdb9b960433899e
  CHECKSUM(SHA256) upstream package : cc4f28168ca447be4fd6d8adc458a98ed0a578757d27eb4ebfdb9b960433899e



Largely ok, the mixture of %{buildroot} and $RPM_BUILD_ROOT is largely cosmetic, but please do fix it to consistently use on or the other form prior to doing any official builds.


APPROVED.    

I will sponsor you here shortly.  welcome to fedora.
Comment 5 Jamie Lennox 2013-10-01 23:51:15 EDT
New Package SCM Request
=======================
Package Name: python-falcon
Short Description: A supersonic micro-framework for building cloud APIs
Owners: jamielennox
Branches: f18 f19 f20 el6 
InitialCC:
Comment 6 Gwyn Ciesla 2013-10-03 08:16:59 EDT
Git done (by process-git-requests).
Comment 7 Fedora Update System 2013-10-03 21:51:01 EDT
python-falcon-0.1.7-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/python-falcon-0.1.7-1.fc18
Comment 8 Fedora Update System 2013-10-03 22:06:38 EDT
python-falcon-0.1.7-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/python-falcon-0.1.7-1.fc19
Comment 9 Fedora Update System 2013-10-03 22:07:55 EDT
python-falcon-0.1.7-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/python-falcon-0.1.7-1.fc20
Comment 10 Fedora Update System 2013-10-15 02:39:48 EDT
python-falcon-0.1.7-1.fc20 has been pushed to the Fedora 20 stable repository.
Comment 11 Fedora Update System 2013-10-18 15:49:22 EDT
python-falcon-0.1.7-1.fc18 has been pushed to the Fedora 18 stable repository.
Comment 12 Fedora Update System 2013-10-18 15:53:51 EDT
python-falcon-0.1.7-1.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.